struct ff_periodic_effect
Prev | Chapter 25. Input Subsystem | Next

## Name

struct ff_periodic_effect — defines parameters of a periodic force-feedback effect

## Synopsis

    struct ff_periodic_effect {
      __u16 waveform;
      __u16 period;
      __s16 magnitude;
      __s16 offset;
      __u16 phase;
      struct ff_envelope envelope;
      __u32 custom_len;
      __s16 * custom_data;
    };

## Members

waveform

  kind of the effect (wave)

period

  period of the wave (ms)

magnitude

  peak value

offset

  mean value of the wave (roughly)

phase

  'horizontal' shift

envelope

  envelope data

custom_len

  number of samples (FF_CUSTOM only)

custom_data

  buffer of samples (FF_CUSTOM only)

## Description

Known waveforms - FF_SQUARE, FF_TRIANGLE, FF_SINE, FF_SAW_UP, FF_SAW_DOWN, FF_CUSTOM. The exact syntax FF_CUSTOM is undefined for the time being as no driver supports it yet.

## Note

the data pointed by custom_data is copied by the driver. You can therefore dispose of the memory after the upload/update.

Prev | Up | Next
struct ff_condition_effect | Home | struct ff_rumble_effect